/*-------------------------------------------------------------------------*\
  <module.C> -- Module implementation file

  Date      Programmer  Description
  03/19/07  Dennis      Created.
\*-------------------------------------------------------------------------*/

#include "module.h"
#include "xmlserializer.h"
#include "btconst.h"
#include <string.h>

BTModule::BTModule()
 : name(NULL), author(NULL), content(NULL), startX(0), startY(0), startFace(0), maxItems(8), maxParty(7), maxTime(14400), nightTime(7200), bonusStacking(true), knowledgeSaved(false), development(false)
{
 duration = new char[strlen("data/duration.xml") + 1];
 strcpy(duration, "data/duration.xml");
 itemType = new char[strlen("data/itemtype.xml") + 1];
 strcpy(itemType, "data/itemtype.xml");
 item = new char[strlen("DEFAULT.ITM") + 1];
 strcpy(item, "DEFAULT.ITM");
 monster = new char[strlen("DEFAULT.MON") + 1];
 strcpy(monster, "DEFAULT.MON");
 spell = new char[strlen("DEFAULT.SPL") + 1];
 strcpy(spell, "DEFAULT.SPL");
 race = new char[strlen("data/race.xml") + 1];
 strcpy(race, "data/race.xml");
 skill = new char[strlen("data/skill.xml") + 1];
 strcpy(skill, "data/skill.xml");
 song = new char[strlen("data/song.xml") + 1];
 strcpy(song, "data/song.xml");
 specialFlag = new char[strlen("data/specialflag.xml") + 1];
 strcpy(specialFlag, "data/specialflag.xml");
 xpChart = new char[strlen("data/experience.xml") + 1];
 strcpy(xpChart, "data/experience.xml");
 job = new char[strlen("data/job.xml") + 1];
 strcpy(job, "data/job.xml");
 level = new char[strlen("level.xml") + 1];
 strcpy(level, "level.xml");
 title = new char[strlen("USRSCR.LBM") + 1];
 strcpy(title, "USRSCR.LBM");
 wall = new char[strlen("data/wall.xml") + 1];
 strcpy(wall, "data/wall.xml");
}

BTModule::~BTModule()
{
 if (name)
  delete [] name;
 if (author)
  delete [] author;
 if (content)
  delete [] content;
 if (itemType)
  delete [] itemType;
 if (item)
  delete [] item;
 if (monster)
  delete [] monster;
 if (spell)
  delete [] spell;
 if (race)
  delete [] race;
 if (skill)
  delete [] skill;
 if (song)
  delete [] song;
 if (specialFlag)
  delete [] specialFlag;
 if (xpChart)
  delete [] xpChart;
 if (job)
  delete [] job;
 if (level)
  delete [] level;
 if (title)
  delete [] title;
 if (wall)
  delete [] wall;
}

void BTModule::serialize(ObjectSerializer* s)
{
 s->add("name", &name);
 s->add("author", &author);
 s->add("content", &content);
 s->add("itemType", &itemType);
 s->add("item", &item);
 s->add("monster", &monster);
 s->add("spell", &spell);
 s->add("race", &race);
 s->add("skill", &skill);
 s->add("song", &song);
 s->add("specialFlag", &specialFlag);
 s->add("xpChart", &xpChart);
 s->add("job", &job);
 s->add("level", &level);
 s->add("title", &title);
 s->add("wall", &wall);
 s->add("startMap", &startMap);
 s->add("startX", &startX);
 s->add("startY", &startY);
 s->add("startFace", &startFace, NULL, &directionsLookup);
 s->add("maxItems", &maxItems);
 s->add("maxParty", &maxParty);
 s->add("maxTime", &maxTime);
 s->add("nightTime", &nightTime);
 s->add("bonusStacking", &bonusStacking);
 s->add("knowledgeSaved", &knowledgeSaved);
 s->add("development", &development);
}
